#include "strucPATH.h"

void c2r2(Complex<Real> **a, int n, double **g, Complex<Real> *fvec, double *b)

/* input: a contains jacobian matrix  (1/9/2002)
    	  fvec for RHS of the linear equation.
   output: g 2n x 2n converted real matrix.
	  b 2n-vector
*/

{
int i,j,k;
double tmp,tmp1;

for (i=1;i<=n;i++) {		// convert C^n to R^2n
    for (j=1;j<=n;j++) {	// (a -b; b a) transformation
        g[2*i-1][2*j-1]=real(a[i][j]);
        g[2*i-1][2*j]=-imag(a[i][j]);
        g[2*i][2*j-1]=imag(a[i][j]);
        g[2*i][2*j]=real(a[i][j]);
    }
}

//for (i=1;i<=n;i++) {for (j=1;j<=n;j++) cout<<" g "<<g[i][j]; cout<<endl;}
for (i=1;i<=n;i++) {
    b[2*i-1]=real(fvec[i]);
    b[2*i]=imag(fvec[i]);
}

}

void r2c(double *dx, int n, Complex<Real> *p )
// convert 2n-vector dx to (n)-complex vector p 
{

int i,j;

for (i=1;i<=n;i++) {
    p[i]=Complex<Real>(dx[2*i-1],dx[2*i]);
}

}
 
