#ifndef SL_COMPLEX_CTESTS_H
#define SL_COMPLEX_CTESTS_H

/*
 ******************************
 * Scientific Library (GNU Public Licence)
 *
 * Author: Laurent Deniau, Laurent.Deniau@cern.ch
 *
 * $Id: ctests.h,v 1.6 1998/07/09 07:05:50 paubert Exp $
 *
 * Suggestions: sl@mathinsa.insa-lyon.fr
 * Bugs:   sl-bugs@mathinsa.insa-lyon.fr
 *
 * For more information, please see the sl++ Home Page:
 * http://wwwinfo.cern.ch/~ldeniau/sl.html
 *
 ******************************
 */

#ifndef SL_COMPLEX_H
#error <sl/complex/ctests.h> must be included via <sl/complex.h>
#endif

#ifdef HAVE_NAMESPACE
namespace sl 
{
#endif

// Not
//#ifdef HAVE_ALTERNATIVE_TOKEN
//template <typename T>
//inline Bool
//not (Complex<T> const& z) 
//{
//  return !z;
//}
//#endif
 
// Equal To

template <typename T1, typename T2>
inline Bool
operator == (Complex<T1> const& z1, Complex<T2> const& z2)
{
  return re(z1)==re(z2) && im(z1)==im(z2);
}

template <typename T>
inline Bool
operator == (Complex<T> const& z, T const x) 
{
  return re(z)==x && !im(z);
}

template <typename T>
inline Bool
operator == (T const x, Complex<T> const& z) 
{
  return re(z)==x && !im(z);
}

// Not Equal To
#ifndef HAVE_SWAP_IN_STL
template <typename T1, typename T2>
inline Bool
operator != (Complex<T1> const& z1, Complex<T2> const& z2)
{
    return re(z1)!=re(z2) || im(z1)!=im(z2);
}
#endif

template <typename T>
inline Bool
operator != (Complex<T> const& z, T const x) 
{
  return re(z)!=x || im(z);
}

template <typename T>
inline Bool
operator != (T const x, Complex<T> const& z) 
{
  return re(z)!=x || im(z);
}

#ifdef HAVE_NAMESPACE
}
#endif

#endif
