#include "inputQ.h"

void   InData(Binomials& Problem)
//
//      Read the problem data from a file specified by Di form
//
{
        int     ii, i, j, k,coeffSW ;
        int	*auxInd, *auxInd1, *auxInd2;
	float   val,vali	; 		// need float for scanf %f
	double  dval,dvali	; 	
	Complex<Real>  valc;
	char	ch,randomCoef[40];
        FILE    *InputFile, *ParaFile;

        if ((InputFile = fopen(Problem.InputFileName, "r")) == NULL) {
                printf(" cannot open -- %s \n", Problem.InputFileName);
                exit(1);
        }
	ii=1;
// read no. of Q_i's
// read no of x elements, or equivalently, no. of equations  
// auxInd later has info on the number of nonzero terms in each equation.
	coeffSW = 1;	// +1: read input coefficient without sign change
			// -1: read input coefficient with sign change

	Problem.numQ = 1;			// take numQ =1 
        Skipwords(InputFile, 61);               // 61 == "="
        fscanf(InputFile, "%d", &Problem.xDim); 
       	Skipwords(InputFile, 61);               
	auxInd1 = new int [Problem.xDim+1]; // no of nonzero item in each eq
	for ( i = 1; i <= Problem.xDim; i++ ) {	
		fscanf(InputFile, "%d", &auxInd1[i]);
	}

	Problem.Allocate(Problem.numQ,auxInd1,Problem.xDim);
        for ( i = 1; i <= Problem.xDim; i++) {
                for ( j = 1; j <= auxInd1[i]; j++) {
                        Skipwords(InputFile, 61);
                        for ( k = 1; k <= Problem.xDim; k++) {
// val indicates the power of the term jk ( i: eq, j:term, k:component in x)
                        	fscanf(InputFile, "%f", &val);
				Problem.Qx[ii].Power[i][j][k]=val;

                        }
                }
        }

// Read original coefficient of H(x)
        for ( i = 1; i <= Problem.xDim; i++) {
                for ( j = 1; j <= auxInd1[i]; j++) {
                  Skipwords(InputFile, 61);         // 61 == "="
                  fscanf(InputFile, "%f", &val);
	          Problem.Qx[ii].StoreCoef_ori(i,j,val);
                  Skipwords(InputFile, 61);         // skip imaginary part of original coeff
                }
        }
// Read generic coefficients of H(x)
        for ( i = 1; i <= Problem.xDim; i++) {
                 for ( j = 1; j <= auxInd1[i]; j++) {
        	      Skipwords(InputFile, 61);          // 61 == "="
                      fscanf(InputFile, "%lf", &dval);
                      Skipwords(InputFile, 61);          // 61 == "="
                      fscanf(InputFile, "%lf", &dvali);
                      valc=Complex<>(dval,dvali);
		      if (coeffSW == -1) valc= -valc;
		      Problem.Qx[ii].Coef[i][j]=valc;
		      Problem.Qx[ii].CoefSav[i][j]=valc;
                 }
        }
// allocate tThreshL & U, copy numTerm
	Problem.Step.Allocate(Problem.xDim,Problem.Qx[1].numTerm);
	Problem.Step.numTerm=
			Problem.Qx[1].numTerm; 
        fclose(InputFile);
//=======================================================================================
// open parameter file
        if ((ParaFile = fopen(Problem.InputFileNamePa, "r")) == NULL) {
               	printf(" cannot open -- %s \n", Problem.InputFileNamePa);
               	exit(1);
 	}
// set preset parameters
	Problem.Qx[ii].inputFormat = -1;	// 1: old format(monomial info), 0:new format
	Problem.Step.informationLevel = 0;	
		//-2: No screen info, Simplest information, no *.note file
		//-1: Simplest information, no *.note file
		//0: Additional information on power of t, etc and min Eigenvalue 
		//	in *.note file when it becomes small.	
		//+1: More information at every iteration in *.note file.
	Problem.Qx[ii].modSW = 0;	//  0: default, paths starting from all initial
					//    	points are computed.
					//  1: Only paths of initial points 1, 1+n, 2+n
					// 	in each cell computed. From the type-2
					// 	symmetry in the cyclic polynomial
	//Skipwords(ParaFile, 61);         // 61 == "="
	//fscanf(ParaFile, "%d", &j);	// instead of reading parameters, set the number.
	//Problem.Qx[ii].corrItMax = j; 
	Problem.Qx[ii].corrItMax = 10; 
	//Skipwords(ParaFile, 61);       
	//fscanf(ParaFile, "%f", &val);
	//Problem.Qx[ii].hValMin = val; 
	Problem.Qx[ii].hValMin = 1.0e-6; 

	//Skipwords(ParaFile, 61);       
	//fscanf(ParaFile, "%d", &j);
	//Problem.Qx[ii].Verbose = j; 
	Problem.Qx[ii].Verbose = 0; 	// flag for output during the run(debug)

	Skipwords(ParaFile, 61);         
	fscanf(ParaFile, "%f", &val);
	Problem.Step.accINfVal = val; 

	Skipwords(ParaFile, 61);        
	fscanf(ParaFile, "%f", &val);
	Problem.Step.accInNewtonDir = val; 

	Skipwords(ParaFile, 61);       
	fscanf(ParaFile, "%f", &val);
	Problem.Qx[ii].beta = val; 

	//Skipwords(ParaFile, 61);       
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.Final2hvalMin = val; 
	Problem.Step.Final2hvalMin = 1.e-9;

	//Skipwords(ParaFile, 61);      
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.Final2distMin = val; 
	Problem.Step.Final2distMin = 1.e-7; 

	//Skipwords(ParaFile, 61);    
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.neglSmallNumber=val;
	Problem.Step.neglSmallNumber=1.e-40; 	// smaller number to ignore

	//Skipwords(ParaFile, 61);   
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.angleMin=val;
	Problem.Step.angleMin=0.90;	// smaller angle than Min to retry predictor

	//Skipwords(ParaFile, 61);       
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.angleThUp=val;
	Problem.Step.angleThUp=99.5;	// lager angle than Up to expand step size

	//Skipwords(ParaFile, 61);         
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.angleThDown=val;
	Problem.Step.angleThDown=0.95;  // smaller angle than Down to keep current size

	//Skipwords(ParaFile, 61);       
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.pStepMin=val;
	Problem.Step.pStepMin=1.0e-10;	// minimum predictor step length allowed

	//Skipwords(ParaFile, 61);      
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.pStepMax=val;
	Problem.Step.pStepMax=0.1;	// max predictor step size allowed

	//Skipwords(ParaFile, 61);     
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.predStep0=val;
	Problem.Step.predStep0=0.01;	// pStepMax*0.1; initial predictor step size

	//Skipwords(ParaFile, 61);    
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.pStepMax2=val;
	Problem.Step.pStepMax2=0.1;	// max step size increase in t^{power}

	//Skipwords(ParaFile, 61);   
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.expansionFactor=val;
	Problem.Step.expansionFactor=1.414;	

	//Skipwords(ParaFile, 61);         
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.reductionFactor=val;
	Problem.Step.reductionFactor=0.707;

	//Skipwords(ParaFile, 61);        
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.dTauMin=val;
	Problem.Step.dTauMin=1.0e-18;	//smallest predictor step size in tauRef space
		// if dTau becomes smaller than dTauMin, stop predictor iteration and all.

	//Skipwords(ParaFile, 61);      
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.dTau0=val;
	Problem.Step.dTau0=0.01;    // 0.1*dTauMax; initial predictor step size in tauRef

	//Skipwords(ParaFile, 61);     
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.dTauPredOrder=val;
	Problem.Step.dTauPredOrder=5.0e-10;	//dTau < dTauPredOrder then predOrer 1

	//Skipwords(ParaFile, 61);   
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.divValueOFt=val;
	Problem.Step.divValueOFt=0.99999;  // if divValueOFt <t, divMagnitude<norm(x,inf)
		// and 1.0/norm(dx,inf) less divRatio, regard it divergence of the curve

	Skipwords(ParaFile, 61);  
	fscanf(ParaFile, "%f", &val);
	Problem.Step.divMagOFx=val;	

	Skipwords(ParaFile, 61);       
	fscanf(ParaFile, "%f", &val);
	Problem.Step.dTauMax=val;	

	//Skipwords(ParaFile, 61); 
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.divRatio=val;
	Problem.Step.divRatio=1.0e-6;

	//Skipwords(ParaFile, 61);   
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.divNormOFdx=val;
	Problem.Step.divNormOFdx=1.0;

	// the following  two values are multiplied by
        // the norm of the initial iterate of the corrector procedure
        // before starting the corrector procedure, namely,
        // distMax : distMax * normOFx;
        // distThreshold : distThreshold * normOFx;
        // where normOFx : max([norm(xtCurrent(1:nDim,1),inf),1]);

	//Skipwords(ParaFile, 61);    
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.distMin=val;
	Problem.Step.distMin=1.0e-6;

	Skipwords(ParaFile, 61);     
	fscanf(ParaFile, "%f", &val);
	Problem.Qx[ii].minEigForNonsing = val; 
	//Problem.Qx[ii].minEigForNonsing = 1.e-10; 

	Skipwords(ParaFile, 61);   
	fscanf(ParaFile, "%f", &val);
	Problem.Step.NewtonDirMax=val;

	Skipwords(ParaFile, 61);        
	fscanf(ParaFile, "%f", &val);
	Problem.Step.predItMax=val;
	//Problem.Step.predItMax=20000;  	// max no. of iterations in predictor

	//Skipwords(ParaFile, 61);  
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.distThreshold=val;
	Problem.Step.distThreshold=1.0e-2;

	//Skipwords(ParaFile, 61); 
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.ctThreshold=val;
	Problem.Step.ctThreshold=0.1;

	//Skipwords(ParaFile, 61); 
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.ctMax=val;
	Problem.Step.ctMax=0.9;

	//Skipwords(ParaFile, 61);
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.cITthreshold=val;
	Problem.Step.cITthreshold=2;

	//Skipwords(ParaFile, 61);     
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.tauValIntoNewton=val;
	Problem.Step.tauValIntoNewton=0.99; //if(tauRef>eq FinalTauValue)&&
		// divMagnitude<normOFx && (normOFdx*(1.0-tCurrent)>divNormOFdx 
		// eq>divergence

	//Skipwords(ParaFile, 61);    
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.tValIntoNewton=val;
	Problem.Step.tValIntoNewton=0.999;

	//Skipwords(ParaFile, 61);   
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.FinaldistMax=val;
	Problem.Step.FinaldistMax=1.e-1;

	//Skipwords(ParaFile, 61);  
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.FinalCorrItMax=val;
	Problem.Step.FinalCorrItMax=20;

	//Skipwords(ParaFile, 61);  
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.tEqualTo1=1.0-val;
	Problem.Step.tEqualTo1=1.0-1.e-15;

	//Skipwords(ParaFile, 61); 
	//fscanf(ParaFile, "%f", &val);
	//Problem.Step.tauEqualTo1=1.0-val;
	Problem.Step.tauEqualTo1=1.0-1.e-15;

	//Skipwords(ParaFile, 61); 
	//fscanf(ParaFile, "%f", &val);
	//Problem.Qx[ii].extSmallNumber=val;
	Problem.Qx[ii].extSmallNumber=1.e-50;

        fclose(ParaFile);
}
//--------------------------------------------------------------------------------------------------------
#include "inDataCell.h"
void InDataCell(Binomials &Problem)
{
        int     ii, i, j, k ;
        int	*auxInd, *auxInd1, *auxInd2;
	float   val,vali	; 		// need float for scanf %f
	double  dval,dvali,minPower	; 	
	Complex<Real>  valc;
        FILE    *InputFile;

        if ((InputFile = fopen(Problem.InputFileCell, "r")) == NULL) {
                printf(" cannot open -- %s \n", Problem.InputFileCell);
                exit(1);
        }
	ii=1;
//--------------------------------------------------------------------------------------------------------
        Skipwords(InputFile, 61);         
     	if( Problem.Qx[ii].inputFormat ==1)	// old format
	 	Skipwords(InputFile, 61);       // skip dimension     
	auxInd2 = new int [Problem.numQ+1]; // no of sol. in each Q
	for ( i = 1; i <= Problem.numQ; i++ )	
		fscanf(InputFile, "%d", &auxInd2[i]);
//     	Skipwords(InputFile, 61);               
	Problem.Allocate4Sol(Problem.numQ,auxInd2[1],Problem.xDim);
	ii=1;
	
	if (Problem.Qx[ii].inputFormat == 1) { 	//old or new input(monomial)
		for ( i = 1; i <= 6*Problem.xDim; i++) { // skip monimial/bino
                	Skipwords(InputFile, 61);      
		}
	}
// Read solutions from the binomial Q_i(x).
	for ( j = 1; j <= Problem.Qx[ii].numSol; j++) {
		Skipwords(InputFile, 61);         // 61 == "="
		for ( k = 1; k <= Problem.Qx[ii].xDim; k++) {
			fscanf(InputFile, "%lf", &dval);
			fscanf(InputFile, "%lf", &dvali);
			valc=Complex<>(dval,dvali);
			Problem.Qx[ii].StoreSol(j,k,valc);
		}
	}
// Read the power of t in each term and contraints of H(x)
// 10/29/01 changes: minPower computed ------------------->
	minPower = 1.e100;
	for ( i = 1; i <= Problem.xDim; i++) {
		Skipwords(InputFile, 61);         // 61 == "="
		for ( j = 1; j <= Problem.Qx[ii].numTerm[i]; j++) {
			fscanf(InputFile, "%f", &val);
			//if(val < 0)  nrerror(" negative power of t");
			Problem.Qx[ii].StoreT(i,j,val);
			if (val> 1.e-50) 	// find minPower
				minPower=DMIN(minPower,val);
		}
	}
	Problem.Qx[ii].gammaP=DMIN(Problem.Qx[ii].beta,minPower); //take min as gammaP
// compute and store powerT/gammaP
	for ( i = 1; i <= Problem.xDim; i++) {
		for ( j = 1; j <= Problem.Qx[ii].numTerm[i]; j++) {
			Problem.Qx[ii].powerT[i][j] /=Problem.Qx[ii].gammaP;
		}
	}
	// other changes included in funcv.c, jacob1.cpp
// <-------------------------------------------------------
        fclose(InputFile);
}
//====================================================================================
void   Skipwords(FILE *input, int skipNum)
{
        char    ch;

        do {
                fscanf(input, "%c", &ch);
		if(ch == 35) {		// if #
			do {		// read until the end of line
                	    fscanf(input, "%c", &ch);
			} while (ch!=10)     ;
		}
        } while (ch != skipNum);
}


void   Initialize(Binomials& Problem, char* FileName1,char* FileNamePa)
//
//      Initialize the input and output file names. 
//
{
        strcpy(Problem.InputFileName, FileName1); // *.dat2
        strcpy(Problem.InputFileCell, FileName1); // *1... In the same directory.
        strcpy(Problem.InputFileNamePa, FileNamePa);
}
 void   MakeHeader(Binomials& Problem)
//
//      Write the comments and the program parameters into the output files
// 	and at the screen.
//
{
        ofstream   OutputFile;
        OutputFile.open(Problem.OutputFileName);
        if (!OutputFile) {
                cerr << "Can not open file : " << Problem.OutputFileName << "\n";
                exit(1);
        }
        OutputFile << "****** Homotopy Method "; 
        OutputFile.close();
} 
