#include "strucPATH.h"
void indexx(int n, double arr[], int indx[], int istack[]);
void qrdcmp(Complex<Real> **a, int n, Complex<Real> *c, Complex<Real> *d, int *sing);
void qrsolv(Complex<Real> **a, int n, Complex<Real> c[], Complex<Real> d[], Complex<Real> b[]);
void svdcmp(double **a, int m, int n, double w[], double **v);
void svbksb(double **u, double w[], double **v, int m, int n, double b[], double tmp[] );
void c2r2(Complex<Real> **a, int n, double **g, Complex<Real> *fvec, double *b);
void r2c(double *dx, int n, Complex<Real> *p );
double twoNormR( double fvec[], int n);

void jacob(PathFollow &P, double t, Complex<Real> x[],  Complex<Real> H[], Complex<Real> Ht[], double rowScaling[], double colScaling[],double tauRef, double powerRef )
{
int i,j,k,l,n,m,mm, NoColScaling;
double d,tpower,beGa,normRightHand; 
Complex<Real> oneTerm,nextCoef;
n = P.xDim; 
// if the number of terms is not changed for combined homotopy, adjust P.Coef[i][j]
// to include generic and original coefficients with t. (6/17/01)

// 10/29/01 changes --------------------------------------------->
tpower=pow(t,P.beta/P.gammaP);
for  (i=1;i<=n;i++)  {
     for (j=1;j<=P.numTerm[i];j++)
          P.Coef[i][j]=P.CoefSav[i][j]+(P.Coef_ori[i][j]-P.CoefSav[i][j])*tpower;
}
// <------------------------------------------------------------
//indx=new int [n+1];
  for (i=1; i <= n; i++){			// i for equation 
    for (j=1; j <= n; j++) {	// j for diff w.r.t.the variable
	P.Hjac[i][j]= Complex<>(0.0,0.0);
	    for ( l=1; l <= P.numTerm[i]; l++) {
	        if (  P.Power[i][l][j] != 0.0) {
		    oneTerm =  P.Coef[i][l]* P.Power[i][l][j]*
				//(pow(t,P.powerT[i][l]))*
				(pow(tauRef,(P.powerT[i][l])/powerRef))*
				( pow(x[j],(P.Power[i][l][j]-1.0) ));
		    for (m=1; m <=n; m++) 
		        if(m !=j)  oneTerm *=pow(x[m],P.Power[i][l][m]);    
		    P.Hjac[i][j] += oneTerm;
		}
	    }
    if(P.Verbose>=4) cout << "Hx jac" << i<<" "<<j<<" "<<P.Hjac[i][j]<<endl;
    }
 }

 // Compute Ht in dydx
for (i=1; i <=n; i++) {
    Ht[i]= oneTerm=Complex<>(0.0,0.0);

    for (k=1; k <= P.numTerm[i]; k++) {
        oneTerm = 1.0;
        for (j=1;j <= n; j++) 
             oneTerm *=  pow(x[j],P.Power[i][k][j]) ;
        
	if (tauRef ==0.0 && P.powerT[i][k] ==1) // special case
            Ht[i] += oneTerm* P.Coef[i][k];
	else if(tauRef !=0)    
            Ht[i] += oneTerm* P.Coef[i][k]*P.powerT[i][k]*
		( pow(tauRef,(P.powerT[i][k]-1.0)/powerRef));
    }

}	// end of i (component of H) loop

if(P.Verbose >=2) for(i=1; i<=n; i++) cout <<"Ht"<< i<<" "<<Ht[i]<<endl;
//-----------------------------------------------------------------------------       
// not to have twice number of terms in cheater's homotopy, modify coefficients and
// add code like function evalution to have derivative w.r.t. t. to computed Ht[i].
// 6/17/01. P.cc[] is used to store values temporarily.
//---------------------------------------------------------------------------------
// 10/29/01 changes -----------------------------> affects only second term for Ht
beGa=P.beta/P.gammaP;
for (i=1;i<=n;i++) {		// adjust coefficient
  for (j=1;j<=P.numTerm[i];j++) {
//     if (t !=0) 
        P.Coef[i][j]=(P.Coef_ori[i][j]-P.CoefSav[i][j])*(beGa)*pow(t,(beGa-1.0));
 //    else
 //       P.Coef[i][j]=0.0;
  }
}

//<----------------------------10/29/01
// add second differentiated term to Ht[i]. (Differentiating H w.r.t.t involves 2 terms)
for (i=1; i <=n; i++) {
  P.cc[i]=oneTerm = Complex<>(0.0,0.0);
//----------------------------------------------------------------------
// comes from plain computation of H.
      for (k=1; k <= P.numTerm[i]; k++) {
            oneTerm = 1.0;
            for (j=1;j <= n; j++) {
                 oneTerm *=  pow(x[j],P.Power[i][k][j]) ;
            }
            P.cc[i] += oneTerm* P.Coef[i][k]*( pow(tauRef,P.powerT[i][k]/powerRef));
      }
      Ht[i] +=P.cc[i]; // add second term of differentiation w.r.t.t.
//cout<<" Ht "<<Ht[i]<<endl;
}

//-----------------------------------------------------------------------------
NoColScaling =0; 		// to prevent dividing by 0 in colScaling
if (P.scalingSW >=1 ) {
	for (i=1;i<=n;i++) {
	 	for (j=1;j<=n;j++) 
			P.Hjac[i][j] /= rowScaling[i];
		Ht[i] /= rowScaling[i];  	// scaling Ht vector.
		colScaling[i]=1.0;	// initialize colScaling
	}
	if (P.scalingSW ==2 ) {
	    for (i=1;i<=n;i++) {
		colScaling[i] =abs(P.Hjac[1][i]); // initialize with first ele
		    for (j =2;j<=n;j++) 
		        colScaling[i]=DMAX(colScaling[i],abs(P.Hjac[j][i]));
		    if(colScaling[i] == 0) NoColScaling=1;
	    }
	    if (NoColScaling !=1) {
	    	for (i=1;i<=n;i++) {
	 	    for (j=1;j<=n;j++) {
			P.Hjac[i][j] /= colScaling[j];
		    }
	        }
	    }
	    
	}
}	
//for(i=1;i<=n;i++) cout<< "row "<<rowScaling[i]<<" "<<colScaling[i]<<endl;
// compute normOFdx
for (i=1;i<=n;i++) {
	P.cc[i]=0.0;
	for ( j=1;j<=n;j++) {
		P.cc[i]+=P.Hjac[i][j]*H[j];
//     cout << "Hx jac" << i<<" "<<j<<" "<<P.Hjac[i][j]<<endl;
	}
}
for (P.normOFdx=0.0,i=1;i<=n;i++) P.normOFdx += norm(P.cc[i]);  // 2-norm	
P.normOFdx = sqrt(P.normOFdx);

for (i=1;i<=n;i++) {
	Ht[i] = -Ht[i];	// direction
	P.cc[i]=0.0;	// clear up cc
}

// for(i=1; i<=n; i++) for(j=1; j<=n; j++) cout <<"Hjac "<< i<<" "<<P.Hjac[i][j]<<endl;
        c2r2(P.Hjac,n,P.GMat,Ht,P.HtR);      // convert to R^2n space & RHS
	svdcmp(P.GMat,2*n,2*n,P.svdW,P.svdV);
	//if (P.svdW[1]> 1.e+20) printf('\n\n normOfDhMatrix > %+8.3e\n\n',P.svdW[1]);
	normRightHand=twoNormR(P.HtR,2*n);
	for (i=1; i<=2*n; i++) 
		P.svdW[i] = DMAX(P.svdW[i],DMIN(P.extSmallNumber,normRightHand));
	svbksb(P.GMat,P.svdW,P.svdV,2*n,2*n,P.HtR,P.ccR);
        r2c(P.HtR,n,Ht);  			// convert back to complex

//=== For debugging ==================================================
// for(i=1; i<=n; i++) for(j=1; j<=n; j++) cout << "P" << i<<" "<<P.Coef[i][j]<<endl;
// for(i=1; i<=n; i++)	cout << "x jacob" << x[i]<< " "<<Ht[i]<<" t "<<t<<endl;
}
