#include "newtArmijo.h" 
extern int nn;

void newtArmijo(PathFollow &P, StepCtrl &S, int *corrIteration, double t, Complex<Real> x[], Complex<Real> hValCurrent[],
int *statusFinal, double tauRef, double powerRef, double *rowScaling, double *colScaling,
	void (*funcv)(PathFollow &, double, Complex<Real> [], Complex<Real> [], double [], double ,double ))

/* Input  */
{
int i,j,n; 
double dist,FinaldistMax,accInNewtonDir,
	hValError,hValErr2,normOFx;
//Complex<Real> csum;
double csum;

int	ArmijoItMax,totalArmijoIT,successSW,ArmijoIT;
double	ArmijoRate, stepReductionRate, hValReductionRate,hValErr0,stepLength,
	expectedErr2,movedDist;

n=P.xDim;
nn=n; 
ArmijoItMax = 30;		// Parameters
ArmijoRate = 1.0e-6;
stepReductionRate = 0.5;
hValReductionRate = 0.99;

normOFx=DMAX(twoNorm(x,n),1.0);
//FinaldistMax=S.FinaldistMax*normOF ;
accInNewtonDir= DMIN(S.accInNewtonDir*normOFx,0.0001);
//Final2distMin= DMIN(S.Final2distMin*normOFx,0.0001);

P.scalingSW=0;
*statusFinal=0; // 0: continue
		// 3: suceed, converged to a nondegerate solution
		// 4: succeed, converged to a degenerate solution
		// 5: Armijo iterations exceeds ArmijoItMax
		// 6: Corrector iteration exceeds FinalCorrItMax
		// 7: not enough decrease in hValError in 100 corrector it.
hValError=fmin(P,t,x,hValCurrent,rowScaling,1.0,1.0);	
		//hValCurrent is also computed by this call.  x:xtCurrent
hValErr2=twoNorm(hValCurrent,n);

fdjac(P,t,x,rowScaling,colScaling,1.0,1.0); 
		// solve Newton equation for p(=dx)
c2r2(P.Hjac,n,P.GMat,hValCurrent,P.HtR); // convert to R^2n space & RHS
svdcmp(P.GMat,2*n,2*n,P.svdW,P.svdV);
P.minEig=P.svdW[1];			// Find minEig^2.
for (i=2; i<=2*n; i++) P.minEig = DMIN(P.minEig,P.svdW[i]);
P.minEig *=P.minEig;

for (i=1; i<=2*n; i++)  { 	// small perturbation for nonsingularity of W
        P.svdW[i] = DMAX(P.svdW[i],DMIN(P.extSmallNumber,hValErr2));
	P.HtR[i] = -P.HtR[i]; 		//take negative sign for Newton eq.
}
svbksb(P.GMat,P.svdW,P.svdV,2*n,2*n,P.HtR,P.ccR);
r2c(P.HtR,n,S.p);                        // convert back to complex

if (P.scalingSW ==2) 
	for (i=1;i<=n;i++) S.p[i] /=colScaling[i];

dist = twoNorm(S.p,n);

*corrIteration=0;
for (i=1; i<=n; i++) S.xtVect0[i]=x[i];
hValErr0 =1.0e+100;
totalArmijoIT =0;
while (*statusFinal ==0 ) {
	*corrIteration += 1;
	successSW = 0;
	stepLength = 1.0;
	ArmijoIT = 0;
	while (successSW ==0 ) {
		ArmijoIT += 1;
		csum=0.0;
		for(i=1;i<=n;i++) {	//first take full step
			S.xtNew[i] = x[i] + stepLength*S.p[i];
			csum += norm(hValCurrent[i]);	
		}
		expectedErr2=(1.0-ArmijoRate*(2.0-stepLength)*stepLength)*csum ;     
		funcv(P,t,S.xtNew,S.hValNew,rowScaling,1.0,1.0);	
		for(csum=0.0,i=1;i<=n;i++) csum +=norm(S.hValNew[i]);
		if(csum <= expectedErr2) { // if error is smaller than expected
			successSW =1;		// update x and h
			for (i=1; i<=n; i++) { 
				x[i]=S.xtNew[i];
				hValCurrent[i]=S.hValNew[i];
			}
			hValError=infNorm(hValCurrent,n); //solve Newton eq 4 dx
			fdjac(P,t,x,rowScaling,colScaling,1.0,1.0); 
			hValErr2=twoNorm(hValCurrent,n);
			// solve Newton equation for p(=dx)
			c2r2(P.Hjac,n,P.GMat,hValCurrent,P.HtR); 
			svdcmp(P.GMat,2*n,2*n,P.svdW,P.svdV);
			P.minEig=P.svdW[1];			// Find minEig^2.
			for (i=2; i<=2*n; i++) 
				P.minEig = DMIN(P.minEig,P.svdW[i]);
			P.minEig *=P.minEig;

			for (i=1; i<=2*n; i++)  { 
        		    P.svdW[i] = DMAX(P.svdW[i],DMIN(P.extSmallNumber,hValErr2));
			    P.HtR[i] = -P.HtR[i];
			}
			svbksb(P.GMat,P.svdW,P.svdV,2*n,2*n,P.HtR,P.ccR);
			r2c(P.HtR,n,S.p);              // convert back to complex

			if (P.scalingSW ==2) {
				for (i=1;i<=n;i++) S.p[i] /=colScaling[i];
			}
			dist = twoNorm(S.p,n);
		} else { //if predicted error is larger than expected
			stepLength *=stepReductionRate;
		}
		if (( successSW ==0) && (ArmijoIT > ArmijoItMax) ) {
			successSW = -1;
			*statusFinal = 5;
			for (i=1; i<=n; i++) P.cc[i]=x[i]-S.xtVect0[i];
			movedDist = twoNorm(P.cc,n);
			cout<<" corrIt "<<*corrIteration<<" ArmijoIt "<< ArmijoIT			     <<" hValErr2 "<<hValErr2<<" minEig "<<P.minEig<<
		     " movedDist "<<movedDist<<endl;
		}
	} // end of while successSW ==0
	if (fmod(*corrIteration,100)==1)	{ //print every 100 iteration
		for (i=1; i<=n; i++) P.cc[i]=x[i]-S.xtVect0[i];
		movedDist = twoNorm(P.cc,n);
		if((hValErr2/hValErr0 >hValReductionRate)||(P.minEig <1.0e-31)) {
			*statusFinal =7;
			cout<<" corrIt "<<*corrIteration<<" ArmijoIt "<< ArmijoIT			     <<" hValErr2 "<<hValErr2<<" minEig "<<P.minEig<<
			     " movedDist "<<movedDist<<endl;
		}
		if (*corrIteration >1) {
			cout<<" corrIt "<<*corrIteration<<" ArmijoIt "<< ArmijoIT			     <<" hValErr2 "<<hValErr2<<" minEig "<<P.minEig<<
			     " movedDist "<<movedDist<<endl;
		}
		hValErr0 =hValErr2;
		for (i=1; i<=n; i++) S.xtVect0[i]=x[i];
	}
	if(( hValError < P.hValMin) && (dist < S.accInNewtonDir)) {
		*statusFinal =3;		//nondegerate solution
		if(P.minEig <P.minEigForNonsing)
			*statusFinal =4;	//degenerate solution
	} else if ((P.minEig < P.minEigForNonsing )&&( hValError < S.Final2hvalMin)) {
		*statusFinal = 4; 		//degenerate solution; exit
	} else if ((*corrIteration >=S.FinalCorrItMax) && (*statusFinal==0)) {
		*statusFinal = 6;
		cout<<" corrIt "<<*corrIteration<<" ArmijoIt "<< ArmijoIT			     <<" hValErr2 "<<hValErr2<<" minEig "<<P.minEig<<
		     " movedDist "<<movedDist<<endl;
	}
}		

}
