#include "poly_lin.h"

int poly_lin(int solno,PathFollow &P, StepCtrl &S, Complex<Real> x0Vect[], Complex<Real> xtCurrent[], Complex<Real> hValCurrent[], int *statusP, char *OutputFileNote, char *OutputHeadName) 

{
/* Perform poly hyedral homotopy 
	input: x0Vect 
*/
        int     i,k,j,n,n1,howOften,predOrder,predOrder0;
// Newton
        int     iter;
	double  sum,tmp;
// time & statistics
        struct  tms CPU;
        float   start_time,end_time;
	PrintInfo	Prnt;
	
	int 	oldStatusC,statusC,statusFinal,angleSW;
	double 	predStep,tOld,tauOld, powerOld,tCurrent,tPredicted,
		hValError, tToMaxPower,theta,condGMat,
		tauRef,powerRef,normXtC,hValAccuracy;
	double 	lambda,hValMin1,distMin1,tTarget,hInfErrCurrent,h2ErrCurrent,
		hInfErrTarget,h2ErrTarget,normReductionRate,maxEig,hValErr2;

	P.smallestEig = 100;
	hValAccuracy=1.0e-9;
	n=P.xDim; 
	P.singularSW=0;
	howOften=1;
	predOrder=2;	// 1: first order, 2: second order predictor
	predOrder0=predOrder;
	P.scalingSW=2;	// 0: no scaling, 1: row scaling, 2: row & col scale
// adjust coefficients and power of t for poly_linear homotopy
	if(solno==1) {			// only first time
		scalepw(P);
// sort t power
        	for (i=1; i <= P.xDim; i++)          // i for equation
             		indexx(P.numTerm[i],P.powerT[i],P.sindx[i],P.istack);
	}
// start poly homotopy
	pre4Processing(P,S); 		// decide 

	powerOld=1.0;
	tauOld=0.0;
	predStep=S.dTau0; // set initial predictor step length.
	S.minPredStep=predStep; 
	S.dTau=S.dTau0;
        for (k=1; k <=n; k++) { 
		S.xOld[k]=x0Vect[k];     // save for adaptive
		xtCurrent[k]=S.xOld[k];     // save for adaptive
	}
	tOld=0.0;
	theta=1.0;
	condGMat=1.0;
	P.normOFx=infNorm(S.xOld,n);
        funcv(P,tOld,S.xOld,S.hValOld,S.rowScaling,tauOld,powerOld);
	hValError=infNorm(S.hValOld,n);
        //newt(P,S,&iter,tOld,S.xOld,S.hValOld,&statusC,
	//	tauOld,powerOld,S.rowScaling,S.colScaling,funcv);
	//hValError=infNorm(S.hValOld,n);
			// hValOld needed in the following? ==> not used
        jacob(P,tOld,S.xOld,S.hValOld,S.pDirect0,S.rowScaling,S.colScaling,tauOld, powerOld);
				// P.dv contains pDirect.
	if (P.scalingSW==2) { 	//jacob doesn't have colScaling to Ht,only for Hjac
		for (k=1;k<=P.xDim;k++)	// scale  pdirect        
			S.pDirect0[k] /=S.colScaling[k];
	}
	for (k=1;k<=P.xDim;k++)	{	// save predictor 
		S.pDirect1[k]=S.pDirect0[k];
		S.pDirect2[k]=S.pDirect1[k];
	}

	*statusP=0;	//=0 continue;<=-1 fail & stop predictor it;
			//-2: fail,diverge; -3 fail,too many pred iter;
			//-4: fail, singular jacobian; -1: too small pred step
			//=3: succeed & converge to a nondegenerate solution
			//=4: succeed & converge to a degenerate solution
			//=5: Armijo iteration exceeds ArmijoItMax
			//=6: corrector iterations exceed FinalCorrItMax
			//=7: not enough decrease in hValError in 100 corrector it.
	S.predIteration=0;// initialize counter for predictor.

	S.totalCorrIteration=0;	// for total corrector iteration.
	statusC=0;	//=0 continue;<=-1 failed corrector
			//	and retry predictor with halved step leng;	
			//=1 succeed and keep current predictor step
			//length; >=2 succeed and double predictor
			//step length.
	oldStatusC=-1;
	iter=0;// counter for corrector iterations between two
			// consecutive predictor iterations.
	theta=0.0;tCurrent=0.0;tToMaxPower=0.0; // initialze for print info
	//if (S.informationLevel==1) Prnt.MidPrint(OutputFileNote,
	//	S.predIteration,statusC,
	//	tCurrent,hValError,P.normOFx,predStep,S.dTau,iter,
	//	theta,P.minEig);  // print during the run 
	angleSW=0;	// to avoid an angle checking before the first success of
			// predictor
//for(k=1;k<=n;k++) cout<<" 1st "<<S.pDirect1[k]<<" ";
	while(*statusP>=0 && *statusP<=1  ) {
		S.predIteration +=1;
		if( (angleSW ==0) || (S.dTau < S.dTauPredOrder) || (tCurrent-tOld)< 1.0e-100 )
			predOrder =1;
		else
			predOrder =predOrder0;
		update4Power(tauOld,powerOld,&tauRef,&powerRef,statusP,S);

		//for(k=1;k<=n;k++) S.xtPredicted[k] = 0.0; //clear S.xtPredicted
		tPredicted = pow(tauRef,1.0/powerRef); //store value of t.

		// When t is close to 1, proceed to the final Newton and check
		// for divergence.
		normXtC = twoNorm(xtCurrent,n);
		if ( ( ((P.maxPower-1.0e-2 <=powerRef) || (*statusP==1)) 
			&& (tauRef >= S.tauValIntoNewton )
			&& (tPredicted >= S.tValIntoNewton) ) 
			|| ((tauRef >= S.tauValIntoNewton) && (S.divMagOFx*1.0e+6 < normXtC)) 
			) { 
		    if (tPredicted >=S.tValIntoNewton) 	
		        lambda=pow((tPredicted-S.tValIntoNewton)/(1.0-S.tValIntoNewton),2);
		    hValMin1=lambda*S.accINfVal+(1.0-lambda)*hValAccuracy;
		    distMin1=lambda*S.accInNewtonDir+(1.0-lambda)*S.distMin;
		    tTarget=1.0;
		    predStep = 1.0-tCurrent;

		    if (predOrder==1) {
			for (k=1; k<=n; k++) // update
			    S.xtTarget[k]=xtCurrent[k]+predStep*S.pDirect1[k];
		    } else { 		//predOrder ==2
		        for(k=1;k<=n;k++) { 
		  	    S.secondOrderTerm[k] = 0.5*predStep
				*(predStep/(tCurrent-tOld))
				*(S.pDirect1[k]-S.pDirect0[k]);
			    S.xtTarget[k]=xtCurrent[k]+predStep*S.pDirect1[k]
				+S.secondOrderTerm[k];
		        }
		    }
		    hInfErrCurrent = infNorm(hValCurrent,n); //compute inf norm
		    h2ErrCurrent = twoNorm(hValCurrent,n);   //compute 2-norm
        	    funcv(P,tTarget,S.xtTarget,S.hValTarget, //function evaluati.
			S.rowScaling,1.0,1.0);
		    hInfErrTarget = infNorm(S.hValTarget,n);
		    h2ErrTarget = twoNorm(S.hValTarget,n);
			// check for convergence --->
		    normReductionRate = DMAX(P.normOFdx*(1.0-tCurrent),1.0e-9);
		    if ( ( (hInfErrTarget < S.accINfVal*10.0) &&
		         (h2ErrTarget < h2ErrCurrent*10.0)) 
			|| (S.dTau <S.dTauMin*10.0) ||
		       (tCurrent >=S.tEqualTo1) || ( tauOld >=S.tauEqualTo1) ) {
			for (k=1;k<=n;k++) x0Vect[k]=S.xtTarget[k]; //save
		        newtArmijo(P,S,&iter,tTarget,S.xtTarget, 
				   S.hValPredicted,&statusFinal,tauRef,powerRef,
				   S.rowScaling,S.colScaling,funcv);
				// update xtPredicted as output of xtTarget	
			for(k=1; k<=n; k++) S.xtPredicted[k]=S.xtTarget[k];
			S.totalCorrIteration +=iter;
			*statusP=statusFinal;
				// =3: converged to a nondegenerate solution
				// =4: converged to a degenerate solution
				// =5: Armijo iteration exceeds ArmijoItMax
				// =6: Corrector iteration exceeds FinalCorrItMax
				// =7: not enough decrease in hValError in 100
				//	corrector iterations
		     }
		    if ( ((((0<=*statusP) && (*statusP <=1))|| (5 <=*statusP)) &&
			   ((S.divMagOFx < infNorm(S.xtTarget,n)) &&
			   ((P.normOFdx*normReductionRate) >= S.divNormOFdx))) ||
			   (((tCurrent >=S.tEqualTo1) || (S.dTau <S.dTauMin*10.0))
			   && (hInfErrTarget >=S.accINfVal *1.0e6)) ) {
			   *statusP = -2; // curve diverged. 
			   for (k=1;k<=n; k++)  xtCurrent[k] = S.xtPredicted[k];   
		    } else if (3<=*statusP) {
			   P.scalingSW=0;
			   for (k=1;k<=n; k++)  xtCurrent[k] = S.xtPredicted[k];     
		    }
		// When t is near 1, proceed to final Newton, check divergence 
		} else {  // t << 1.0
		    hValMin1 = hValAccuracy;
		    distMin1 = S.distMin;
		}
//==============================================================================
		// Predictor iteration
		if (( *statusP ==0) || (*statusP ==1)) {
		    predStep = tPredicted-tCurrent;
		    S.minPredStep = DMIN(S.minPredStep,predStep); //4 statistics
		    if (predOrder==1) {
			for (k=1;k<=n;k++) // update
			   S.xtPredicted[k]=xtCurrent[k]+predStep*S.pDirect1[k];
		    } else { //predOrder ==2
		        for(k=1;k<=n;k++) { 
		  	    S.secondOrderTerm[k] = 0.5*predStep
				*(predStep/(tCurrent-tOld))
				*(S.pDirect1[k]-S.pDirect0[k]);
			    S.xtPredicted[k]=xtCurrent[k]+predStep*S.pDirect1[k]
				+S.secondOrderTerm[k];
		        }
		    } 
		    //compute function value at predicted pt.
        	    funcv(P,tPredicted,S.xtPredicted,S.hValPredicted,
			S.rowScaling,tauRef,powerRef);
		    newt(P,S,&iter,tPredicted,S.xtPredicted,S.hValPredicted,&statusC,
			tauRef,powerRef,S.rowScaling,S.colScaling,funcv);
		    S.totalCorrIteration +=iter;
		    if (statusC >=1) { // successful corrector, compute next pred

	            jacob(P,tPredicted,S.xtPredicted,hValCurrent,S.pDirect2,S.rowScaling,S.colScaling,tauRef,powerRef);
			P.minEig = P.svdW[1];	// find minimum eigenvalues of svdW^2
			for (k=2; k<=2*n; k++) P.minEig = DMIN(P.svdW[k],P.minEig);
			P.minEig *= P.minEig; 
		        if (P.scalingSW ==2) {
			    for (k=1;k<=n;k++) S.pDirect2[k] /= S.colScaling[k];	
		        } // end of computing next predictor direction
		        if (angleSW ==1) 
		     	    theta=angleTwo(S.pDirect1,S.pDirect2,n);
		        else 
			    theta= 0.5*(S.angleMin+S.angleThUp);	
			
		    // Compute condition # of coefficient matrix of Newton
		    // for the last iteration( i.e., t=1).
		    // check angle for acceptance.
		        if ( (theta>S.angleMin) || (S.predIteration<=1)) {
			    //if( (S.angleThUp<theta) && (iter<=S.cITthreshold) ) 
			//	statusC=4; //expand predictor step
			 		//length; nearly parallel two vectors 
			 //   else 
			    if ( theta <S.angleThDown)  {
				statusC=1;// keep the length.
			    }	
			    for(k=1;k<=n;k++){ // update for next predictor
				S.xOld[k]=xtCurrent[k];
				xtCurrent[k]=S.xtPredicted[k];
				hValCurrent[k]=S.hValPredicted[k];
				S.pDirect0[k]=S.pDirect1[k];
				S.pDirect1[k]=S.pDirect2[k];
			    }
			    powerOld=powerRef;
			    tauOld = tauRef;
			    tOld=tCurrent;	
			    tCurrent=tPredicted;
			    angleSW=1;
			    P.normOFx=infNorm(xtCurrent,n);
			    P.normOFdx=infNorm(S.pDirect2,n);
		         } else {   	// do not accept the current iterate
			    statusC=-4;
		         }		
		    } // end of "if statusC >=1"
		} 	// end of "if (*statusP ==0) || (*statusP==1)
		if ( (*statusP ==0) ||(*statusP==1) ) {
	 	    if ( S.predItMax < S.predIteration ) 
			*statusP = -3; //predIteration exceeds its maximum.
		    else if (S.dTau < S.dTauMin)//if predStep in tau space gets
						//smaller, abandon predictor 
		    	*statusP = -1;
		    else if (statusC < 0) //reduce the predictor step length
			S.dTau = S.reductionFactor*S.dTau;
		    else if (statusC >= 2) { // expand predictor step length
			if (oldStatusC < 0) 
			    S.dTau =sqrt(S.expansionFactor)*S.dTau;
			else S.dTau=S.expansionFactor * S.dTau;
			if(S.dTau > S.dTauMax) S.dTau=S.dTauMax;
		    } 
		} 
		oldStatusC = statusC;
//===========================================================================
//	write information during the iterations
	    if (S.informationLevel >=0 ) { 
		if ( ((S.informationLevel==1) && ((fmod(S.predIteration,howOften)==1)
		    || (howOften==1))) || ((1<=statusC) && (P.minEig <P.minEigForNonsing)
			&& (P.singularSW == 0)) ) {
			if ( ((1<=statusC) && (P.minEig < P.minEigForNonsing) && 
				(P.singularSW ==0)) ){
				P.singularSW +=1;
				Prnt.HeaderInfo(OutputFileNote);
			} else if ( ( 2<=S.predIteration )&& 
				(fmod(S.predIteration,howOften*20)==1) ) {
				Prnt.HeaderName(OutputFileNote,OutputHeadName,solno,P.numSol);
				Prnt.HeaderInfo(OutputFileNote);
			}
			hValError=infNorm(hValCurrent,n);
			Prnt.MidPrint(OutputFileNote,S.predIteration,statusC,
			1.0-tPredicted,hValError,P.normOFx,
			predStep,S.dTau,iter, theta,P.minEig); // print 
		}
	    } 
	if(P.minEig < P.smallestEig) P.smallestEig=P.minEig;
	} 	// end of while loop.	
//==========================================================================
//	write after while loop
	if (S.informationLevel ==1) {
		Prnt.MidPrint(OutputFileNote,S.predIteration,statusC,
		1.0-tPredicted,hValError,P.normOFx,
		predStep,S.dTau,iter, theta,P.minEig); // print 
	}
//==========================================================================
// Post processing to get information hValError, normOFdx, minEig, condGMat
// with the approximate solution xtCurrent. Singular Value Decomposition
// is used to compute minEig and condGMat.
	P.scalingSW = 0;
	tCurrent = 1.0;
       	funcv(P,tCurrent,xtCurrent,hValCurrent,S.rowScaling,1.0,1.0);
	hValError = infNorm(hValCurrent,n);
	P.normOFx = twoNorm(xtCurrent,n);
	
	fdjac(P,tCurrent,xtCurrent,S.rowScaling,S.colScaling,1.0, 1.0);
        c2r2(P.Hjac,n,P.GMat,hValCurrent,P.HtR);   // convert to R^2n space & RHS
        svdcmp(P.GMat,2*n,2*n,P.svdW,P.svdV);

	P.minEig = 1.0e+100; 	// find minimum eigenvalues of svdW^2
	for (k=1; k<=2*n; k++) P.minEig = DMIN(P.svdW[k],P.minEig);
	P.minEig *= P.minEig; 
	P.maxEig = 0.0; 	// find maximum eigenvalues of svdW^2
	for (k=1; k<=2*n; k++) P.maxEig = DMAX(P.svdW[k],P.maxEig);
	P.maxEig *= P.maxEig; 

        hValErr2=twoNorm(hValCurrent,n);
        for (i=1; i<=2*n; i++) {
                P.svdW[i] = DMAX(P.svdW[i],DMIN(P.extSmallNumber,hValErr2));
		P.HtR[i] = -P.HtR[i];
	}
        svbksb(P.GMat,P.svdW,P.svdV,2*n,2*n,P.HtR,P.ccR);
        r2c(P.HtR,n,P.cc); //P.cc has dx.
	P.normOFdx = twoNorm(P.cc,n);
	P.condNo = sqrt(maxEig/DMAX(1.0e-300,P.minEig)); //condNo =condGMat

//===========================================================================
	return 0;
}		
