//-----------------------------------------------------------------------
// Given binomial Q(x) and its solution, follows the path from
// t=0 to t=1 depending on the method indicated. Find the solution of H(x).
//------------------------------------------------------------------------

#include "main.h"

#define DEBUG 0

int poly_main(int *previousPrint, char *FileName1, char *FileName2, int CellNum, int startCell, int endCell, 
              int FileNameSize, char *SolBuffer, char *StatBuffer, int BufferSize2)
{
        float 	cputime_start,cputime_end,elapse_time;
        struct 	tms CPU;
	int	ii,i,k,j,statusP,celli,increase;
	int     BufferSize;
	double 	infN;
	char	cell[10],start[20],end[10],sol[20],note[20],aDim[20],probName[10];
	FILE    *log;

// Class
	Binomials	B;
	PrintInfo	Prnt;
// Modifies the I/O format
  	ComplexFormat::set(0,0,'i');
// Initialization(get name of input/output data file)

#if DEBUG
	printf("FileName1 = %s, FileName2 = %s, CellNum = %d, startCell = %d, endCell = %d\n",
	       FileName1, FileName2, CellNum, startCell, endCell);
#endif
	Initialize(B, FileName1, FileName2); // copy the i/o file names.
	InData(B); 	// Read input Q(x) and its coefficients and dimension.
	aDim[0]='\0';
	itoa(B.Qx[1].xDim,aDim);	// for file names                 

	probName[0]='\0';
	BufferSize = strlen(B.InputFileCell);
	strncpy(probName,B.InputFileCell+(BufferSize-9),4); // for cycC or ecoC, cycL...
	probName[4]='\0';

	if ( probName[3] != 'L') {	// not linear homotopy, add 1-10 cell indicator
		itoa(startCell,start);		// to form stat file name
		strcat(start,"-");
		itoa(endCell,end);		// from starting cell to ending
		strcat(start,end);		// cell.
	} else {
		start[0]='\0';
	}
	sol[0]='\0';			// clear space
	strcat(sol,start);		// solution file name
	strcat(sol,".sol");		

	strcpy(B.OutputFileName,aDim);
	strcat(B.OutputFileName,probName);
	strcat(B.OutputFileName,sol);

	note[0]='\0';			// clear space
	strcat(note,start);		// note file name
	strcat(note,".note");		
	strcpy(B.OutputFileNote,aDim);
	strcat(B.OutputFileNote,probName);
	strcat(B.OutputFileNote,note);


	strcpy(B.OutputHeadName,aDim);
	strcat(B.OutputHeadName,probName);
	strcpy(B.ClusterName,B.OutputHeadName);  
	strcat(B.OutputHeadName,start); // save for writing head info
	strcat(start,".stat");		// stat file name
	strcpy(B.OutputFileStat,aDim);
	strcat(B.OutputFileStat,probName);
	strcat(B.OutputFileStat,start);

#if !DEBUG
	//cout<<B.InputFileName<<endl;
	//cout<<B.OutputFileName<<endl;
	//cout<<B.OutputFileStat<<endl;
	//cout<<B.OutputFileNote<<endl;
#endif
	BufferSize = strlen(B.InputFileCell);
	fflush(stdout);

	itoa(CellNum,cell);
	start[0]='\0';
	if(probName[3] != 'L') strcpy(B.InputFileCell+(BufferSize-5),cell); // not Linear homo
	if(probName[3] == 'L') strcpy(B.InputFileCell+(BufferSize-5),start); // Linear homo
	
#if DEBUG
	cout<<B.InputFileCell<<endl;
	cout<<B.InputFileName<<endl;
	cout<<B.OutputFileName<<endl;
	cout<<B.OutputFileStat<<endl;
#endif
//================================================================================
//print headings, information, etc to the screen and to *.sol, *.stat, *.note files	
	if((CellNum == startCell) && (B.Step.informationLevel >= -1))  {// only the beginning
	aDim[0] = 's';				// indicate output on screen
	Prnt.Headings(aDim,B);			// write on the screen
	Prnt.Parameters(aDim,B.Step.accINfVal,
		    B.Step.accInNewtonDir,B.Qx[1].beta,B.Step.divMagOFx,B.Step.dTauMax,
		    B.Qx[1].minEigForNonsing,B.Step.NewtonDirMax,B.Step.predItMax,
		    B.Step.informationLevel);
	if( B.Step.informationLevel >=0) {	// write on note file
		Prnt.Headings(B.OutputFileNote, B);
		Prnt.Parameters(B.OutputFileNote,B.Step.accINfVal,
		    B.Step.accInNewtonDir,B.Qx[1].beta,B.Step.divMagOFx,B.Step.dTauMax,
		    B.Qx[1].minEigForNonsing,B.Step.NewtonDirMax,B.Step.predItMax,
		    B.Step.informationLevel);
	}
	Prnt.Headings(B.OutputFileStat, B);  	//  write on stat file
	Prnt.Parameters(B.OutputFileStat,B.Step.accINfVal,
	    B.Step.accInNewtonDir,B.Qx[1].beta,B.Step.divMagOFx,B.Step.dTauMax,
	    B.Qx[1].minEigForNonsing,B.Step.NewtonDirMax,B.Step.predItMax,
	    B.Step.informationLevel);
	Prnt.Headings(B.OutputFileName, B);	// write on sol file
	Prnt.Parameters(B.OutputFileName,B.Step.accINfVal,
	    B.Step.accInNewtonDir,B.Qx[1].beta,B.Step.divMagOFx,B.Step.dTauMax,
	    B.Qx[1].minEigForNonsing,B.Step.NewtonDirMax,B.Step.predItMax,
	    B.Step.informationLevel);
	Prnt.ExpParam(B.OutputFileStat,B.Step.informationLevel);
	}

//=================================================================================	
	B.StatBuffer[0] = '\0';
	B.SolBuffer[0] = '\0';
	InDataCell(B); 	// Read binomial's solution.
	   
#if DEBUG
	cout<<B.InputFileCell<<endl;
	cout<<B.InputFileName<<endl;
	cout<<B.OutputFileName<<endl;
	cout<<B.OutputFileStat<<endl;
	cout << "cell = " << cell << '\n';
#endif
	if(B.Qx[1].modSW ==1) increase = B.Qx[1].xDim;
	else if (B.Qx[1].modSW == 0) increase = 1;
	for ( i=1; i <= B.Qx[1].numSol; i+=increase) {
	     	for (j=1; j<=B.Qx[1].xDim; j++) 
		 	B.xini[j]=B.Qx[1].Sol[i][j];	 // copy a starting point

              	times(&CPU);
              	cputime_start=CPU.tms_utime; 	// Cheater's homotopy
	      	poly_lin(i,B.Qx[1],B.Step,B.xini,B.sav_x,B.Hval,&statusP,B.OutputFileNote,
			B.OutputHeadName);
              	times(&CPU);
              	cputime_end=CPU.tms_utime;
              	elapse_time = (cputime_end-cputime_start)/TIMES_PER_SECOND;
	      	infN=infNorm(B.Hval,B.Qx[1].xDim);
		if (statusP > 5) statusP = 5;
	
		*previousPrint -=1;
		if ((B.Step.informationLevel==1) ||((B.Step.informationLevel>=0)&&(B.Qx[1].singularSW==1)))
	      		Prnt.PrintStatNote(B,elapse_time,i,cell,infN,statusP);
	      	Prnt.PrintStat(B,elapse_time,i,cell,infN,statusP,previousPrint);
	      	if(statusP >=2) Prnt.PrintSol(B,statusP,i,cell,infN);
        }	   

	strcpy(SolBuffer, B.SolBuffer);
	strcpy(StatBuffer, B.StatBuffer);

// 	disallocation for initial Solutions
       	if(B.Qx[1].Sol) {
           	for ( i = 1; i < B.Qx[1].numSol+1; i++ )
			delete [] B.Qx[1].Sol[i];
	        delete [] B.Qx[1].Sol;
                B.Qx[1].Sol  = NULL;
	}
	return 0;
}
