//------------------------------------------------------------------------------
// The current value of t is maintaind in terms of powerRef and tauRef 
// such that tauRef = power(t,powerRef) or t = power(tauRef,1.0/powerRef).
//
//       Update powerRef and tauRef from powerOld and tauOld
//       when tauOld ---> tauRef = power(tauOld,powerRef/powerOld) +dTau 
//			for an appropriate powerRef.
//       Then t=power(tauOld,1.0/powerOld) ---> t'=power(tauRef,1.0/powerRef).
//
// [powerRef,tauRef,statusP]
//=update4Power(powerOld,tauOld,dTau,maxPower,totalNoTerms,tPowerVector,statusP)

#include "strucPATH.h"

void update4Power(double tauOld, double powerOld, double *tauRef, double *powerRef,int *statusP, StepCtrl &S)
{
double tau,logNewT,logTmin;

int k,kk;

logTmin = 0.0; kk=0; *powerRef = 1;
for (k=1;k<=S.totalNoTerms;k++) {
        tau = pow(tauOld,S.tPowerVector[S.tVInd[k]]/powerOld);
        if (tau+S.dTau < 1.0 ) {
                logNewT = log(tau+S.dTau) / S.tPowerVector[S.tVInd[k]];
                if ( logNewT < logTmin ) {
                        kk=k;
                        logTmin = logNewT;
                        *powerRef = S.tPowerVector[S.tVInd[kk]];
                }  
        }  
}
if (kk==0 ) {
        *powerRef = 1;
        *tauRef = 1.0;
        *statusP = 1;
} else {
        *tauRef = exp(*powerRef * logTmin);
//       a = min([2*powerRef,maxPower]);
//       tauRef = power(tauRef,a/powerRef);
//       powerRef = a;
}
}
